/*
 * BadCharacterShiftTable.h
 *
 *  Created on: 5. 11. 2014
 *      Author: Jan Travnicek
 */

#ifndef _ARBOLOGY_BAD_CHARACTER_SHIFT_TABLE_H_
#define _ARBOLOGY_BAD_CHARACTER_SHIFT_TABLE_H_

#include <tree/RankedTreeWrapper.h>
#include <tree/TreeFeatures.h>
#include <core/multipleDispatch.hpp>
#include <alphabet/RankedSymbol.h>

#include <set>
#include <map>

namespace arbology {

namespace exact {

/**
 * Computation of BCS table for BMH from MI(E+\eps)-EVY course 2014
 * To get rid of zeros in BCS table we ignore last haystack character
 */
class BadCharacterShiftTable : public std::SingleDispatch < BadCharacterShiftTable, std::map < alphabet::RankedSymbol, size_t >, tree::RankedTreeBase > {
public:
	/**
	 * Search for pattern in linear string.
	 * @return set set of occurences
	 */
	static std::map < alphabet::RankedSymbol, size_t > bcs ( const tree::RankedTreeWrapper & pattern );

	static std::map < alphabet::RankedSymbol, size_t > bcs ( const tree::PrefixRankedBarPattern & pattern );
	static std::map < alphabet::RankedSymbol, size_t > bcs ( const tree::PrefixRankedBarNonlinearPattern & pattern );

};

} /* namespace exact */

} /* namespace arbology */

#endif /* _ARBOLOGY_BAD_CHARACTER_SHIFT_TABLE_H_ */
