/*
 * Translate.cpp
 *
 *  Created on: 12. 5. 2016
 *      Author: Jakub Doupal
 */

#include "Translate.h"
#include "Run.h"
#include <automaton/PDA/NPDTA.h>

#include <deque>
#include <set>

namespace automaton {

namespace run {

std::set < string::LinearString > Translate::translate ( const automaton::Automaton & automaton, const alib::Object & object ) {
	return dispatch ( automaton.getData ( ), object.getData ( ) );
}

std::set < string::LinearString > Translate::translate ( const automaton::Automaton & automaton, const string::LinearString & string ) {
	return dispatch ( automaton.getData ( ), string );
}

std::set < string::LinearString > Translate::translate ( const automaton::NPDTA & automaton, const string::LinearString & string ) {
	std::tuple < bool, std::set < automaton::State >, std::set < std::vector < alphabet::Symbol > > > res = Run::calculateStates ( automaton, string );
	std::set < string::LinearString > strings;
	for ( auto iter = std::get<2>(res).begin(); iter != std::get<2>(res).end(); iter ++ ) {
		string::LinearString str (* iter);
		strings . insert ( str );
	}
	return strings;
}

auto TranslateNPDTALinearString = Translate::RegistratorWrapper < std::set < string::LinearString >, automaton::NPDTA, string::LinearString > ( Translate::translate );

} /* namespace run */

} /* namespace automaton */
