/*
 * AutomatonIteration.cpp
 *
 *  Created on: 29. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "AutomatonIteration.h"

namespace automaton {

namespace transform {

automaton::Automaton AutomatonIteration::iteration(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

template<class T>
automaton::NFA AutomatonIteration::iteration(const T& automaton) {
	automaton::NFA res(automaton);

	for(const auto& qf : res.getFinalStates())
		for(const auto& t : res.getTransitionsToState(qf))
			res.addTransition(t.first.first, t.first.second, res.getInitialState());

	res.addFinalState(automaton.getInitialState());
	return res;
}

auto AutomatonIterationDFA = AutomatonIteration::RegistratorWrapper<automaton::NFA, automaton::DFA>(AutomatonIteration::iteration);
auto AutomatonIterationNFA = AutomatonIteration::RegistratorWrapper<automaton::NFA, automaton::NFA>(AutomatonIteration::iteration);

} /* namespace transform */

} /* namespace automaton */
