/*
 * Compaction.h
 *
 *  Created on: 2. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef COMPACTION_H_
#define COMPACTION_H_

#include <core/multipleDispatch.hpp>
#include "automaton/Automaton.h"

namespace automaton {

namespace transform {

/**
 * Transforms FSM to CompactNFA
 */
class Compaction : public std::SingleDispatch<Compaction, automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::CompactNFA convert( const automaton::DFA& automaton);
	static automaton::CompactNFA convert( const automaton::NFA& automaton);
	static automaton::CompactNFA convert( const automaton::CompactNFA& automaton);

	/**
	 * Transforms
	 * @param automaton FSM to transform
	 * @return CompactNFA equivalent to given automaton
	 */
	static automaton::Automaton convert( const automaton::Automaton & automaton );
};

} /* namespace transform */

} /* namespace automaton */

#endif /* COMPACTION_H_ */
