/*
 * PDAToRHPDA.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef PDA_TO_RHPDA_H_
#define PDA_TO_RHPDA_H_

#include <core/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>

#include "automaton/Automaton.h"
#include <automaton/common/State.h>

namespace automaton {

class PDAToRHPDA : public std::SingleDispatch<PDAToRHPDA, automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::RealTimeHeightDeterministicDPDA convert( const automaton::RealTimeHeightDeterministicDPDA & pda);
	static automaton::RealTimeHeightDeterministicDPDA convert( const automaton::DPDA & pda);
	static automaton::RealTimeHeightDeterministicNPDA convert( const automaton::RealTimeHeightDeterministicNPDA & pda);
	static automaton::RealTimeHeightDeterministicNPDA convert( const automaton::NPDA & pda);

	/**
	 * Computes epsilon closure of a state in epsilon nonfree automaton
	 */
	static automaton::Automaton convert( const automaton::Automaton & automaton );
};

}

#endif /* PDA_TO_RHPDA_H_ */
