/*
 * ToAutomatonBototmUp.h
 *
 * Created on: 20. 5. 2015
 * Author: Tomas Pecka
 */

#ifndef _GRAMMAR_TO_AUTOMATON_BOTTOMUP_H_
#define _GRAMMAR_TO_AUTOMATON_BOTTOMUP_H_

#include <core/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <grammar/ContextFree/CFG.h>
#include <grammar/ContextFree/EpsilonFreeCFG.h>

#include <automaton/Automaton.h>
#include <automaton/PDA/NPDA.h>

namespace grammar {

namespace convert {

/**
 */
class ToAutomatonBottomUp : public std::SingleDispatch<ToAutomatonBottomUp, automaton::Automaton, grammar::GrammarBase> {
public:
	/**
	 * Performs conversion.
	 */
	static automaton::Automaton convert(const grammar::Grammar& grammar);

	template <class T>
	static automaton::NPDA convert(const T& grammar);
};

} /* namespace convert */

} /* namespace grammar */

#endif /* _GRAMMAR_TO_AUTOMATON_BOTTOMUP_H_ */
