/*
 * First.h
 *
 *  Created on: 9. 6. 2015
 *	  Author: Tomas Pecka, Jan Travnicek
 */

#ifndef FIRST_H_
#define FIRST_H_

#include <core/multipleDispatch.hpp>
#include <grammar/Grammar.h>
#include <alphabet/Symbol.h>
#include <string/Epsilon.h>
#include <vector>
#include <set>
#include <variant>

namespace grammar {

namespace parsing {

class First;

typedef std::map < std::vector < alphabet::Symbol >, std::set < std::variant < alphabet::Symbol, string::Epsilon > > > FirstResult1;
typedef std::SingleDispatch < First, FirstResult1, grammar::GrammarBase > FirstBase1;

typedef std::set < std::variant < alphabet::Symbol, string::Epsilon > > FirstResult2;
typedef std::SingleDispatchLastStaticParam < First, FirstResult2, grammar::GrammarBase, const std::vector < alphabet::Symbol > & > FirstBase2;

class First : public FirstBase1, public FirstBase2 {
	static std::set < std::variant < alphabet::Symbol, string::Epsilon > > first ( const std::set < alphabet::Symbol > & terminals, const std::set < alphabet::Symbol > & nonterminals, const std::map < alphabet::Symbol, std::set < std::variant < alphabet::Symbol, string::Epsilon > > > & firstOfNonterminal, const std::vector < alphabet::Symbol > & rhs );

	static std::map < alphabet::Symbol, std::set < std::variant < alphabet::Symbol, string::Epsilon > > > first ( const std::set < alphabet::Symbol > & terminals, const std::set < alphabet::Symbol > & nonterminals, const std::map < alphabet::Symbol, std::set < std::vector < alphabet::Symbol > > > & rules );

public:
	template < class T >
	static FirstResult1 first ( const T & grammar );

	template < class T >
	static FirstResult2 first ( const T & grammar, const std::vector < alphabet::Symbol > & rhs );

	static FirstResult1 first ( const grammar::Grammar & grammar );

	static FirstResult2 first ( const grammar::Grammar & grammar, const std::vector < alphabet::Symbol > & rhs );

};

} /* namespace parsing */

} /* namespace grammar */

#endif /* FIRST_H_ */
