/*
 * Substitute.cpp
 *
 *  Created on: 9. 6. 2015
 *	  Author: Jan Travnicek
 */

#include "Substitute.h"
#include <grammar/ContextFree/CFG.h>

namespace grammar {

namespace parsing {

void Substitute::substitute ( const grammar::CFG & orig, grammar::CFG & res, const alphabet::Symbol & origLHS, const std::vector < alphabet::Symbol > & origRHS, std::vector < alphabet::Symbol >::const_iterator nonterminal ) {
	auto iter = orig.getRules ( ).find ( * nonterminal );

	if ( iter == orig.getRules ( ).end ( ) ) return;

	for ( const std::vector < alphabet::Symbol > & rhs : iter->second ) {
		std::vector < alphabet::Symbol > newRHS ( origRHS.begin ( ), nonterminal );
		newRHS.insert ( newRHS.end ( ), rhs.begin ( ), rhs.end ( ) );
		newRHS.insert ( newRHS.end ( ), nonterminal + 1, origRHS.end ( ) );
		res.addRule ( origLHS, newRHS );
	}
}

} /* namespace parsing */

} /* namespace grammar */
