/*
 * Trim.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef GRAMMAR_TRIM_H_
#define GRAMMAR_TRIM_H_

#include <core/multipleDispatch.hpp>
#include <grammar/Grammar.h>

namespace grammar {

namespace simplify {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class Trim : public std::SingleDispatch<Trim, grammar::Grammar, grammar::GrammarBase> {
public:
	static grammar::Grammar trim( const grammar::Grammar & grammar );

	/**
	 * Removes unproductive and useless symbols - Melichar 3.12
	 */
	template<class T>
	static T trim( const T & grammar );
};

} /* namespace simplify */

} /* namespace grammar */

#endif /* GRAMMAR_TRIM_H_ */
