/*
 * RegExpConcatenate.h
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_CONCATENATE_H_
#define REG_EXP_CONCATENATE_H_

#include <core/multipleDispatch.hpp>

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExp.h>
#include <regexp/unbounded/UnboundedRegExp.h>

namespace regexp {

/**
 * Concatenates two regexpses
 *
 */
class RegExpConcatenate : public std::PromotingDoubleDispatch<RegExpConcatenate, regexp::RegExp, regexp::RegExpBase> {
public:
	static regexp::RegExp concatenate(const regexp::RegExp& first, const regexp::RegExp& second);

	static regexp::FormalRegExp concatenate(const regexp::FormalRegExp& first, const regexp::FormalRegExp& second);
	static regexp::UnboundedRegExp concatenate(const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second);
};

} /* namespace regexp */

#endif /* REG_EXP_CONCATENATE_H_ */
