/*
 * GlushkovSymbol.cpp
 *
 *  Created on: 14. 4. 2016
 *	  Author: Tomas Pecka
 */

#include "GlushkovSymbol.h"

namespace rte {

GlushkovSymbol::GlushkovSymbol ( rte::FormalRTESymbol const * const & node, int i ) : m_Symbol ( node ), m_i ( i ) {
}

bool GlushkovSymbol::operator <( GlushkovSymbol const & x ) const {
	return m_i < x.m_i;
}

int GlushkovSymbol::getId ( void ) const {
	return m_i;
}

alphabet::RankedSymbol GlushkovSymbol::getInputSymbol ( void ) const {
	return m_Symbol->getSymbol ( );
}

rte::FormalRTESymbol const * GlushkovSymbol::getSymbolPtr ( void ) const {
	return m_Symbol;
}

} /* namespace rte */
