/*
 * GlushkovSymbol.h
 *
 *  Created on: 14. 4. 2016
 *	  Author: Tomas Pecka
 */

#ifndef RTE_GLUSHKOVSYMBOL_H_
#define RTE_GLUSHKOVSYMBOL_H_

#include <alphabet/Symbol.h>
#include <rte/formal/FormalRTESymbol.h>

namespace rte {

/**
 * Represents numbered symbol in glushkov algorithm.
 */
class GlushkovSymbol {
private:
	rte::FormalRTESymbol const * const m_Symbol;
	int m_i;

public:
	GlushkovSymbol ( rte::FormalRTESymbol const * const & node, int i );
	bool operator <( GlushkovSymbol const & x ) const;
	int getId ( void ) const;
	alphabet::RankedSymbol getInputSymbol ( void ) const;
	rte::FormalRTESymbol const * getSymbolPtr ( void ) const;
};

} /* namespace rte */

#endif /* GLUSHKOVSYMBOL_H_ */
