/*
 * ExactCompare.h
 *
 *  Created on: Oct 14, 2014
 *	  Author: Radomir Polach
 */

#ifndef EXACT_COMPARE_H_
#define EXACT_COMPARE_H_

#include <core/multipleDispatch.hpp>
#include <string/String.h>
#include <string/StringFeatures.h>

namespace string {

namespace naive {

class ExactCompare : public std::PromotingDoubleDispatch<ExactCompare, int, string::StringBase> {
public:
	static int compare(const string::String& u, const string::String& v);

	static int compare(const string::Epsilon& u, const string::Epsilon& v);
	static int compare(const string::LinearString& u, const string::LinearString& v);
	static int compare(const string::CyclicString& u, const string::CyclicString& v);
};

} /* namespace naive */

} /* namespace string */

#endif /* EXACT_COMPARE_H_ */
