/*
 * ExactEqual.h
 *
 *  Created on: Oct 14, 2014
 *	  Author: Radomir Polach
 */

#ifndef EXACT_EQUAL_H_
#define EXACT_EQUAL_H_

#include <core/multipleDispatch.hpp>
#include <string/String.h>
#include <string/StringFeatures.h>

namespace string {

namespace naive {

class ExactEqual : public std::PromotingDoubleDispatch<ExactEqual, bool, string::StringBase> {
public:
	static bool equals(const string::String& u, const string::String& v);

	static bool equals(const string::Epsilon& u, const string::Epsilon& v);
	static bool equals(const string::LinearString& u, const string::LinearString& v);
	static bool equals(const string::CyclicString& u, const string::CyclicString& v);
};

} /* namespace naive */

} /* namespace string */

#endif /* EXACT_EQUAL_H_ */
