/*
 * NormalizeAlphabet.h
 *
 *  Created on: Dec 9, 2013
 *	  Author: Jan Travnicek
 */

#ifndef NORMALIZE_ALPHABET_H_
#define NORMALIZE_ALPHABET_H_

#include <core/multipleDispatch.hpp>

#include <string/LinearString.h>
#include <string/String.h>

namespace string {

namespace simplify {

class NormalizeAlphabet : public std::SingleDispatch<NormalizeAlphabet, string::String, string::StringBase> {
public:
	/**
	 * @param dfa automaton to normalize
	 */
	static string::String normalize(const string::String& str);

	static string::LinearString normalize(const string::LinearString& str);
};

} /* namespace simplify */

} /* namespace string */

#endif /* NORMALIZE_ALPHABET_H_ */
