/*
 * ReversedBadCharacterShiftTable.h
 *
 *  Created on: 5. 11. 2014
 *      Author: Jan Travnicek
 */

#ifndef _STRINGOLOGY_REVERSED_BAD_CHARACTER_SHIFT_TABLE_H_
#define _STRINGOLOGY_REVERSED_BAD_CHARACTER_SHIFT_TABLE_H_

#include <string/String.h>
#include <string/StringFeatures.h>
#include <core/multipleDispatch.hpp>

#include <set>
#include <map>

namespace stringology {

namespace exact {

/**
 * Computation of BCS table for BMH from MI(E+\eps)-EVY course 2014
 * To get rid of zeros in BCS table we ignore last haystack character
 */
class ReversedBadCharacterShiftTable : public std::SingleDispatch < ReversedBadCharacterShiftTable, std::map < alphabet::Symbol, size_t >, string::StringBase > {
public:
	/**
	 * Search for pattern in linear string.
	 * @return set set of occurences
	 */
	static std::map < alphabet::Symbol, size_t > bcs ( const string::String & pattern );

	static std::map < alphabet::Symbol, size_t > bcs ( const string::LinearString & pattern );

};

} /* namespace exact */

} /* namespace stringology */

#endif /* _STRINGOLOGY_REVERSED_BAD_CHARACTER_SHIFT_TABLE_H_ */
