/*
 * RandomTreeFactory.h
 *
 *  Created on: 18. 3. 2015
 *	  Author: Stepan Plachy
 */

#ifndef RANDOM_TREE_FACTORY_H_
#define RANDOM_TREE_FACTORY_H_

#include <deque>
#include <set>
#include <climits>

#include <alphabet/RankedSymbol.h>
#include <alphabet/LabeledSymbol.h>
#include <tree/ranked/RankedTree.h>
#include <tree/ranked/RankedPattern.h>
#include <tree/ranked/RankedNonlinearPattern.h>
#include <tree/unranked/UnrankedTree.h>
#include <tree/unranked/UnrankedPattern.h>

namespace tree {

namespace generate {

class RandomTreeFactory {
public:
	static tree::RankedTree generateRankedTree ( int depth, int nodesCount, int maxAlphabetSize, bool randomizedAlphabet, int maxRank = INT_MAX );
	static tree::RankedPattern generateRankedPattern ( int depth, int nodesCount, int maxAlphabetSize, bool randomizedAlphabet, int maxRank = INT_MAX );
	static tree::RankedNonlinearPattern generateRankedNonlinearPattern ( int depth, int nodesCount, int maxAlphabetSize, bool randomizedAlphabet, int maxRank = INT_MAX );
	static tree::UnrankedTree generateUnrankedTree ( int depth, int nodesCount, int maxAlphabetSize, bool randomizedAlphabet, int maxRank = INT_MAX );
	static tree::UnrankedPattern generateUnrankedPattern ( int depth, int nodesCount, int maxAlphabetSize, bool randomizedAlphabet, int maxRank = INT_MAX );

private:
};

} /* namespace generate */

} /* namespace tree */

#endif /* RANDOM_TREE_FACTORY_H_ */
