#include <list>
#include "normalizeTest.h"

#include "automaton/simplify/Normalize.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( normalizeTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( normalizeTest );

void normalizeTest::setUp() {
}

void normalizeTest::tearDown() {
}

void normalizeTest::testNormalize() {
  automaton::DFA automaton(automaton::State(0));

  automaton.addState(automaton::State(0));
  automaton.addState(automaton::State(1));
  automaton.addState(automaton::State(2));
  automaton.addInputSymbol(alphabet::symbolFrom("a"));
  automaton.addInputSymbol(alphabet::symbolFrom("b"));
  
  automaton.addTransition(automaton::State(0), alphabet::symbolFrom("a"), automaton::State(1));
  automaton.addTransition(automaton::State(1), alphabet::symbolFrom("b"), automaton::State(2));

  automaton.addFinalState(automaton::State(2));
  
  automaton::DFA normalized = automaton::simplify::Normalize::normalize(automaton);

  CPPUNIT_ASSERT(normalized.getStates().size() == 3);

  CPPUNIT_ASSERT(automaton == normalized);
}
