#ifndef SLR1_PARSE_TABLE_TEST_H_
#define SLR1_PARSE_TABLE_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class SLR1ParseTable : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( SLR1ParseTable );
	CPPUNIT_TEST ( testActionTable );
	CPPUNIT_TEST ( testGotoTable );
	CPPUNIT_TEST ( testUnambiguousNotSLR1Grammar );
	CPPUNIT_TEST_SUITE_END ( );

	alphabet::Symbol E = alphabet::symbolFrom ( 'E' );
	alphabet::Symbol T = alphabet::symbolFrom ( 'T' );
	alphabet::Symbol F = alphabet::symbolFrom ( 'F' );

	alphabet::Symbol plus = alphabet::symbolFrom ( '+' );
	alphabet::Symbol times = alphabet::symbolFrom ( '*' );
	alphabet::Symbol leftParenthesis = alphabet::symbolFrom ( '(' );
	alphabet::Symbol rightParenthesis = alphabet::symbolFrom ( ')' );
	alphabet::Symbol identifier = alphabet::symbolFrom ( "id" );
	
	grammar::CFG getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testActionTable ( );
	void testGotoTable ( );
	void testUnambiguousNotSLR1Grammar ( );
};

#endif /* SLR1_PARSE_TABLE_TEST_H_ */
