/*
 * LRParserTypes.h
 *
 *  Created on: 10. 5. 2016
 *	  Author: Martin Kocicka
 */

#ifndef LR_PARSER_TYPES_H_
#define LR_PARSER_TYPES_H_

#include "../../alphabet/Symbol.h"
#include "../../automaton/common/State.h"

#include <map>
#include <set>
#include <variant>
#include <vector>

namespace grammar {

namespace parsing {

enum class LRAction {
	Shift,
	Reduce,
	Accept
};

typedef std::map < alphabet::Symbol, std::set < std::pair < unsigned, std::vector < alphabet::Symbol > > > > LR0Items;
typedef std::map < std::pair < automaton::State, alphabet::Symbol >, std::pair < LRAction, std::variant < automaton::State, std::pair < alphabet::Symbol, std::vector < alphabet::Symbol > > > > > LRActionTable;
typedef std::map < std::pair < automaton::State, alphabet::Symbol >, automaton::State > LRGotoTable;

} /* namespace parsing */

} /* namespace grammar */

#endif /* LR_PARSER_TYPES_H_ */
