/*
 * RegExp.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef REG_EXP_H_
#define REG_EXP_H_

#include <base/WrapperBase.hpp>
#include "RegExpBase.h"

#include "../alphabet/SymbolFeatures.h"
#include "../string/StringFeatures.h"
#include <string>
#include <set>

namespace regexp {

/**
 * Wrapper around automata.
 */
class RegExp : public alib::WrapperBase < RegExpBase > {
	using alib::WrapperBase < RegExpBase >::WrapperBase;

public:
	const std::set < alphabet::Symbol > & getAlphabet ( ) const;

	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "RegExpRef";

		return xmlTagName;
	}
};

regexp::RegExp regexpFrom ( const std::string & string );

regexp::RegExp regexpFrom ( const char * string );

regexp::RegExp regexpFrom ( string::LinearString string );

regexp::RegExp regexpFrom ( alphabet::Symbol symbol );

regexp::RegExp regexpFrom ( );

} /* namespace regexp */

#endif /* REG_EXP_H_ */
