/*
 * FormalRegExpElement.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "FormalRegExpElement.h"
#include <typeinfo>

#include "FormalRegExpElements.h"

#include "../common/RegExpFromXMLParser.h"
#include "../common/RegExpToXMLComposer.h"
#include <exception/CommonException.h>

namespace regexp {

std::set < alphabet::Symbol > FormalRegExpElement::computeMinimalAlphabet ( ) const {
	std::set < alphabet::Symbol > res;

	computeMinimalAlphabet ( res );
	return res;
}

} /* namespace regexp */

namespace alib {

std::rvalue_ref < regexp::FormalRegExpElement > xmlApi < regexp::FormalRegExpElement >::parse ( std::deque < sax::Token >::iterator & input ) {
	return regexp::RegExpFromXMLParser::parseFormalRegExpElement ( input );
}

bool xmlApi < regexp::FormalRegExpElement >::first ( const std::deque < sax::Token >::const_iterator & ) {
	throw exception::CommonException ( "Unimplemented" );
}

void xmlApi < regexp::FormalRegExpElement >::compose ( std::deque < sax::Token > & output, const regexp::FormalRegExpElement & data ) {
	data.Accept ( ( void * ) & output, regexp::RegExpToXMLComposer::REGEXP_TO_XML_COMPOSER );
}

} /* namespace alib */
