/*
 * UnboundedRegExpEpsilon.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "UnboundedRegExpEpsilon.h"
#include "../formal/FormalRegExpEpsilon.h"
#include <sstream>

namespace regexp {

UnboundedRegExpEpsilon::UnboundedRegExpEpsilon ( ) {
	// so that default constructor is available
}

UnboundedRegExpElement * UnboundedRegExpEpsilon::clone ( ) const {
	return new UnboundedRegExpEpsilon ( * this );
}

UnboundedRegExpElement * UnboundedRegExpEpsilon::plunder ( ) && {
	return new UnboundedRegExpEpsilon ( std::move ( * this ) );
}

std::smart_ptr < FormalRegExpElement > UnboundedRegExpEpsilon::asFormal ( ) const {
	return std::smart_ptr < FormalRegExpElement > ( new FormalRegExpEpsilon ( ) );
}

int UnboundedRegExpEpsilon::compare ( const UnboundedRegExpEpsilon & ) const {
	return 0;
}

void UnboundedRegExpEpsilon::operator >>( std::ostream & out ) const {
	out << "(UnboundedRegExpEpsilon)";
}

bool UnboundedRegExpEpsilon::testSymbol ( const alphabet::Symbol & ) const {
	return false;
}

bool UnboundedRegExpEpsilon::checkAlphabet ( const std::set < alphabet::Symbol > & ) const {
	return true;
}

void UnboundedRegExpEpsilon::computeMinimalAlphabet ( std::set < alphabet::Symbol > & ) const {
}

UnboundedRegExpEpsilon::operator std::string ( ) const {
	std::stringstream ss;
	ss << * this;
	return ss.str ( );
}

} /* namespace regexp */
