#ifndef RTE_H_
#define RTE_H_

#include <base/WrapperBase.hpp>
#include "RTEBase.h"

#include "../alphabet/SymbolFeatures.h"
#include "../string/StringFeatures.h"
#include <string>
#include <set>

namespace rte {

/**
 * Wrapper around automata.
 */
class RTE : public alib::WrapperBase < RTEBase > {
	using alib::WrapperBase < RTEBase >::WrapperBase;

public:
	const std::set < alphabet::RankedSymbol > & getAlphabet ( ) const;
	const std::set < alphabet::RankedSymbol > & getConstantAlphabet ( ) const;

	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "RTERef";

		return xmlTagName;
	}
};

/*
 * rte::RTE rteFrom ( const std::string & string );
 * rte::RTE rteFrom ( const char * string );
 * rte::RTE rteFrom ( string::LinearString string );
 * rte::RTE rteFrom ( alphabet::Symbol symbol );
 * rte::RTE rteFrom ( );
 */

} /* namespace rte */

namespace std {

template < >
struct compare < rte::RTE > {
	int operator ()( const rte::RTE & first, const rte::RTE & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} /* namespace std */

#endif /* RTE_H_ */
