/*
 * String.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "String.h"
#include "LinearString.h"
#include "CyclicString.h"
#include "Epsilon.h"
#include <XmlApi.hpp>

namespace string {

const std::set < alphabet::Symbol > & String::getAlphabet ( ) const {
	return this->getData ( ).getAlphabet ( );
}

void String::extendAlphabet ( const std::set < alphabet::Symbol > & symbols ) {
	this->getData ( ).extendAlphabet ( symbols );
}

string::String stringFrom ( const alphabet::Symbol & symbol ) {
	return string::String {
			   string::LinearString {
				   std::vector < alphabet::Symbol > {
					   symbol
				   }
			   }
	};
}

string::String stringFrom ( const std::string & string ) {
	return string::String {
			   string::LinearString {
				   string
			   }
	};
}

string::String stringFrom ( const char * string ) {
	return stringFrom ( ( std::string ) string );
}

} /* namespace string */

namespace alib {

auto StringDeleter = xmlApi < string::String >::InputContextDeleter ( );
}
