/*
 * RankedTreeWrapper.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef RANKED_TREE_WRAPPER_H_
#define RANKED_TREE_WRAPPER_H_

#include <base/WrapperBase.hpp>
#include "RankedTreeBase.h"

namespace tree {

/**
 * Wrapper around tree.
 */
class RankedTreeWrapper : public alib::WrapperBase < RankedTreeBase > {
	using alib::WrapperBase < RankedTreeBase >::WrapperBase;

public:
	const std::set < alphabet::RankedSymbol > & getAlphabet ( ) const;
	void extendAlphabet ( const std::set < alphabet::RankedSymbol > & symbols );

	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "RankedTreeWrapperRef";

		return xmlTagName;
	}
};

} /* namespace tree */

#endif /* RANKED_TREE_WRAPPER_H- */
