/*
 * TreeAuxiliary.cpp
 *
 *  Created on: May 5, 2016
 *      Author: Jan Travnicek
 */

#include "TreeAuxiliary.h"
#include <algorithm>

namespace tree {

std::set < alphabet::Symbol > TreeAuxiliary::unrankSymbols ( const std::set < alphabet::RankedSymbol > & alphabet ) {
	return std::transform < alphabet::Symbol > ( alphabet, [&] ( const alphabet::RankedSymbol & symbol) {
			return symbol.getSymbol ( );
	} );
}

std::set < alphabet::RankedSymbol > TreeAuxiliary::computeBars ( const std::set < alphabet::RankedSymbol > & alphabet, const alphabet::Symbol & barBase ) {
	return std::transform < alphabet::RankedSymbol > ( alphabet, [&] ( const alphabet::RankedSymbol & symbol) {
			return alphabet::RankedSymbol ( barBase, symbol.getRank ( ) );
	} );
}

} /* namespace tree */
