/*
 * UnreachableStatesRemover.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef EFFICIENT_UNREACHABLE_STATES_REMOVER_H_
#define EFFICIENT_UNREACHABLE_STATES_REMOVER_H_

#include <core/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>
#include <automaton/Automaton.h>

namespace automaton {

namespace simplify {

namespace efficient {

class UnreachableStatesRemover : public std::SingleDispatch<UnreachableStatesRemover, automaton::Automaton, automaton::AutomatonBase> {
public:
	static automaton::Automaton remove( const automaton::Automaton & automaton );

	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static T remove( const T & automaton );
};

} /* namespace efficient */

} /* namespace simplify */

} /* namespace automaton */

#endif /* EFFICIENT_UNREACHABLE_STATES_REMOVER_H_ */
