/*
 * compare.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef __COMPARE_HPP_
#define __COMPARE_HPP_

namespace std {

template < typename T, typename Enable = void >
struct compare;

template<>
struct compare<bool> {
	int operator()(bool first, bool second) const {
		return first - second;
	}
};

template<>
struct compare<int> {
	int operator()(int first, int second) const {
		return first - second;
	}
};

template<>
struct compare<double> {
	int operator()(double first, double second) const {
		return first - second;
	}
};

template<class T>
struct compare<T*> {
	int operator()( T * const & first, T * const & second) const {
		compare<typename std::decay < T >::type > comp;
		return comp(*first, *second);
	}
};

} /* namespace std */

#endif /* __COMPARE_HPP_ */
