#include "AlgorithmTest.h"
#include <algorithm>


CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( AlgorithmTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( AlgorithmTest );

void AlgorithmTest::setUp() {
}

void AlgorithmTest::tearDown() {
}

void AlgorithmTest::testExclude() {
	{
		int array1[] = {1, 2, 3};
		int array2[] = {2, 3, 4};

		std::cout << sizeof(array1) / sizeof(int);

		CPPUNIT_ASSERT(std::excludes(array1, array1 + sizeof(array1) / sizeof(int), array2, array2 + sizeof(array2) / sizeof(int)) == false);
	}

	{
		int array1[] = {1, 3, 5};
		int array2[] = {2, 4, 6, 8};

		CPPUNIT_ASSERT(std::excludes(array1, array1 + sizeof(array1) / sizeof(int), array2, array2 + sizeof(array2) / sizeof(int)) == true);
		CPPUNIT_ASSERT(std::excludes(array2, array2 + sizeof(array2) / sizeof(int), array1, array1 + sizeof(array1) / sizeof(int)) == true);
	}

	{
		int array1[] = {1, 3, 5, 8};
		int array2[] = {2, 4, 6, 8};

		CPPUNIT_ASSERT(std::excludes(array1, array1 + sizeof(array1) / sizeof(int), array2, array2 + sizeof(array2) / sizeof(int)) == false);
		CPPUNIT_ASSERT(std::excludes(array2, array2 + sizeof(array2) / sizeof(int), array1, array1 + sizeof(array1) / sizeof(int)) == false);
	}

	{
		int array1[] = {0};
		int array2[] = {2, 4, 6, 8};

		CPPUNIT_ASSERT(std::excludes(array1, array1 + sizeof(array1) / sizeof(int), array2, array2 + sizeof(array2) / sizeof(int)) == true);
		CPPUNIT_ASSERT(std::excludes(array2, array2 + sizeof(array2) / sizeof(int), array1, array1 + sizeof(array1) / sizeof(int)) == true);

		CPPUNIT_ASSERT(std::excludes(array1, array1, array2, array2) == true);
		CPPUNIT_ASSERT(std::excludes(array2, array2, array1, array1) == true);
	}
}

void AlgorithmTest::testTransform() {
	std::set<int> in = {1, 2, 3, 4};
	std::set<long> ref = {2, 3, 4, 5};

/*	std::function<long(const int&)> lamb = [](const int& elem) { return (long) elem + 1; };
	std::set<long> out = std::transform<long>(in, lamb); //*/

	std::set<long> out = std::transform<long>(in, [](const int& elem) { return (long) elem + 1; });

	CPPUNIT_ASSERT(ref == out);
}
