/*
 * AutomataStat.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef AUTOMATA_STAT_H_
#define AUTOMATA_STAT_H_

#include <core/multipleDispatch.hpp>

#include "automaton/Automaton.h"
#include "automaton/AutomatonFeatures.h"

#include "AutomataSettings.h"

class AutomataStat : public std::SingleDispatchLastStaticParam < AutomataStat, void, automaton::AutomatonBase, const AutomataSettings & > {
public:
	static void stat ( const automaton::Automaton & automaton, const AutomataSettings & settings );

	static void stat ( const automaton::NFA & automaton, const AutomataSettings & settings );
	static void stat ( const automaton::DFA & automaton, const AutomataSettings & settings );

	static void stat ( const automaton::InputDrivenNPDA & automaton, const AutomataSettings & settings );
	static void stat ( const automaton::InputDrivenDPDA & automaton, const AutomataSettings & settings );

	static void stat ( const automaton::DPDA & automaton, const AutomataSettings & settings );
	static void stat ( const automaton::NPDA & automaton, const AutomataSettings & settings );
};

#endif /* AUTOMATA_STAT_H_ */
