/*
 * StringStat.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "StringStat.h"
#include "common/Printer.hpp"

#include <string/LinearString.h>
#include <string/CyclicString.h>

void StringStat::stat ( const string::String & string, const StringSettings & settings ) {
	dispatch ( string.getData ( ), settings );
}

void StringStat::stat ( const string::LinearString & string, const StringSettings & settings ) {
	Printer::PrintSet ( settings.alphabet, string.getAlphabet ( ) );
	Printer::PrintVector ( settings.content, string.getContent ( ) );
}

auto StringStatFormalString = StringStat::RegistratorWrapper < void, string::LinearString > ( StringStat::stat );

void StringStat::stat ( const string::CyclicString & string, const StringSettings & settings ) {
	Printer::PrintSet ( settings.alphabet, string.getAlphabet ( ) );
	Printer::PrintVector ( settings.content, string.getContent ( ) );
}

auto StringStatUnboundedString = StringStat::RegistratorWrapper < void, string::CyclicString > ( StringStat::stat );
